/* junkie - gui ftp client
 * Copyright (c) 2002-2003, Gunnsteinn Hall, Joel Thomas, Martin Faxer
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of the
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
 *  HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * $Id: gui_qwin.h,v 1.18 2003/02/24 15:51:32 thepin Exp $
 */

#ifndef _GUI_QWIN_H
#define _GUI_QWIN_H

#include <gtk/gtk.h>
#include <ftp.h>
#include <queue.h>
#include <jlist.h>


void           gui_qwin_model_show (_ftp_item *);
void           gui_qwin_model_set  (_ftp_item *, GtkTreeView *);
GtkTreeModel * gui_qwin_model_get  (_ftp_item *);
GtkTreeModel * gui_qwin_model_new  ( );
GtkWidget    * gui_qwin_setup      (GtkWidget *);
GtkWidget    * gui_qwin_treeview   ( );

int         gui_qwin_queue_add(_ftp_item *, struct _list *, int, int);
void        gui_qwin_fill_cb(GtkTreeModel *, _queue_item *, GtkTreeIter *);
void        gui_qwin_pixbuf_update(GtkTreeModel *,_queue_item *, GtkTreeIter *);
void        gui_qwin_refresh(GtkTreeModel *);
void        gui_qwin_return_selected(GtkTreeModel *, 
		                             GtkTreePath *, GtkTreeIter *,
									 gpointer);
FTP_CB_CMD(gui_qwin_recurse_remote_cb);

void gui_qwin_double_click_cb(GtkTreeView *, GtkTreePath *, GtkTreeViewColumn *,
		                      gpointer);
void gui_qwin_cell_edited(GtkCellRendererText *, gchar *, gchar *, gpointer);

void gui_qwin_remove_if_transfered(_queue_item **, t_iter *, int, GtkTreeModel *);

#endif
