/* junkie - gui ftp client
 * Copyright (c) 2002-2003, Gunnsteinn Hall, Joel Thomas, Martin Faxer
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of the
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
 *  HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * $Id: gui_tview.h,v 1.32 2003/02/24 15:51:39 thepin Exp $
 */

#ifndef _GUI_TVIEW_H
#define _GUI_TVIEW_H

#include <ftp.h>
#include <gui.h>
#include <ftp_event_callback.h>
#include <misc.h>

void gui_tree_double_click_cb(GtkTreeView *tree,
		                      GtkTreePath *path,
							  GtkTreeViewColumn *,
							  gpointer);
void gui_tview_select(GtkWidget *, gint, gint, GdkEventButton *, gpointer);
GtkWidget *gui_setup_tview(GtkWidget *);
GtkTreeModel *gui_tview_model_setup(GtkTreeView *);
GtkTreeModel *gui_tview_model_init();
void gui_fill_tview_cb(GtkTreeModel *, struct _list *, GtkTreeIter *);
struct _list * gui_sort_type_by_name(struct _list *,int*);
void gui_tree_menu_add_queue(GtkWidget *item, gpointer upointer);
void gui_menu_download(GtkTreeModel *, GtkTreePath *, GtkTreeIter, gpointer);
void gui_menu_add_queue(GtkTreeModel *, GtkTreePath *, GtkTreeIter, gpointer);
void gui_menu_edit_fly(GtkTreeModel *, GtkTreePath *, GtkTreeIter, gpointer);
void gui_menu_edit_fly_done(GIOChannel *, GIOCondition, char **);
FTP_CB_CMD(gui_menu_edit_fly_pending);
void gui_menu_view_fly(GtkTreeModel *, GtkTreePath *, GtkTreeIter, gpointer);
FTP_CB_CMD(gui_menu_view_fly_done);
void gui_menu_delete(GtkTreeModel *, GtkTreePath *, GtkTreeIter, gpointer);
void gui_menu_rename(GtkTreeModel *, GtkTreePath *, GtkTreeIter, gpointer);
void gui_menu_chmod_cb(GtkTreeModel *, GtkTreePath *, GtkTreeIter *, int);
GtkWidget * gui_menu_chmod_box(int, GtkWidget **, t_toggle **,
		                         int *, int *, int *);
void gui_menu_mkdir_local(GtkWidget *, GtkEntry *);
void gui_menu_mkdir_remote(GtkWidget *, GtkEntry *);
void gui_tview_dnd_setup(GtkTreeView *left, GtkTreeView *right);
void gui_tview_dwload(GtkWidget *widget, GdkDragContext *dc,
		gint x, gint y, guint t, GSList *);
void gui_tview_upload(GtkWidget *widget, GdkDragContext *dc,
		gint x, gint y, guint t, GSList *);
void gui_tview_move(GtkWidget *widget, GdkDragContext *dc,
		gint x, gint y, guint t, GSList *);
void gui_tview_ftpmove(GtkWidget *widget, GdkDragContext *dc,
		gint x, gint y, guint t, GSList *);

int gui_treeview_select_bychar(GtkWidget *, GdkEventKey *, gpointer);

gint * gui_tview_get_selected_row(GtkTreeView *);
GtkTreePath * gui_tview_get_selected_path(GtkTreeView *);
GSList * gui_tview_get_selected_row_refs(GtkTreeView *tree);
void gui_tview_return_selected_cb(GtkTreeModel *,
		                            GtkTreePath  *,
											 GtkTreeIter  *,
											 GtkTreeView  *);
int gui_tview_selected_n(GtkTreeView *tree);
void increment(GtkTreeModel *,
		         GtkTreePath  *,
					GtkTreeIter  *,
					int *n);

FTP_CB_CMD(gui_tview_handler_unblock);
int gui_tview_handler_block(GtkWidget *);
#endif
