/* this file is a part of amp software, (C) tomislav uzelac 1996,1997
*/
 
/* getbits.h
 *
 * Created by: tomislav uzelac  Apr 1996
 */

/* gethdr() error codes
*/
#define GETHDR_ERR 0x1
#define GETHDR_NS  0x2
#define GETHDR_FL1 0x4
#define GETHDR_FL2 0x8
#define GETHDR_FF  0x10
#define GETHDR_SYN 0x20
#define GETHDR_EOF 0x30

/* buffer for the 'bit reservoir'
*/
  
/* exports
*/
extern int fillbfr(amp_file *jamp, unsigned int advance);

extern unsigned int getbits(amp_file *jamp, int n);
extern int gethdr(amp_file *jamp, struct AUDIO_HEADER *header);
extern void getcrc(amp_file *jamp);
extern void getinfo(amp_file *jamp, struct AUDIO_HEADER *header,struct SIDE_INFO *info);
extern int dummy_getinfo(amp_file *jamp, int n);
extern int rewind_stream(amp_file *jamp, int nbytes);


#ifdef GETBITS


/* buffer and bit manipulation functions
 */
static inline int _fillbfr(amp_file *jamp, unsigned int size);

static inline int readsync();
static inline int get_input(amp_file *jamp, unsigned char* bp, unsigned int size);
static inline unsigned int _getbits(amp_file *jamp, int n);
int fillbfr(amp_file *jamp, unsigned int advance);
unsigned int getbits(amp_file *jamp, int n);
int dummy_getinfo(amp_file *jamp, int n);
int rewind_stream(amp_file *jamp, int nbytes);

/* header and side info parsing stuff 
 */
static inline void parse_header(amp_file *jamp, struct AUDIO_HEADER *header);
static inline int header_sanity_check(struct AUDIO_HEADER *header);

int gethdr(amp_file *jamp, struct AUDIO_HEADER *header);
void getcrc();
void getinfo(amp_file *jamp, struct AUDIO_HEADER *header,struct SIDE_INFO *info);  

#endif /* GETBITS */

